/*******************************************************************************
 * Copyright (c) 2008-2010 Sonatype, Inc.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *      Sonatype, Inc. - initial API and implementation
 *******************************************************************************/

package org.eclipse.m2e.model.edit.pom;

import org.eclipse.emf.ecore.EObject;


/**
 * <!-- begin-user-doc --> A representation of the model object ' <em><b>Activation Property</b></em>'. <!--
 * end-user-doc --> <!-- begin-model-doc --> 4.0.0 This is the property specification used to activate a profile. If the
 * value field is empty, then the existence of the named property will activate the profile, otherwise it does a
 * case-sensitive match against the property value as well. <!-- end-model-doc -->
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.m2e.model.edit.pom.ActivationProperty#getName <em>Name </em>}</li>
 * <li>{@link org.eclipse.m2e.model.edit.pom.ActivationProperty#getValue <em>Value </em>}</li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.m2e.model.edit.pom.PomPackage#getActivationProperty()
 * @model extendedMetaData="name='ActivationProperty' kind='elementOnly'"
 * @generated
 */
public interface ActivationProperty extends EObject {
  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
   * begin-model-doc --> 4.0.0 The name of the property to be used to activate a profile. <!-- end-model-doc -->
   * 
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.eclipse.m2e.model.edit.pom.PomPackage#getActivationProperty_Name()
   * @model dataType="org.eclipse.emf.ecore.xml.type.String" extendedMetaData=
   *        "kind='element' name='name' namespace='##targetNamespace'"
   * @generated
   */
  String getName();

  /**
   * Sets the value of the ' {@link org.eclipse.m2e.model.edit.pom.ActivationProperty#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * 
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Value</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
   * begin-model-doc --> 4.0.0 The value of the property required to activate a profile. <!-- end-model-doc -->
   * 
   * @return the value of the '<em>Value</em>' attribute.
   * @see #setValue(String)
   * @see org.eclipse.m2e.model.edit.pom.PomPackage#getActivationProperty_Value()
   * @model dataType="org.eclipse.emf.ecore.xml.type.String" extendedMetaData=
   *        "kind='element' name='value' namespace='##targetNamespace'"
   * @generated
   */
  String getValue();

  /**
   * Sets the value of the ' {@link org.eclipse.m2e.model.edit.pom.ActivationProperty#getValue <em>Value</em>}'
   * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
   * 
   * @param value the new value of the '<em>Value</em>' attribute.
   * @see #getValue()
   * @generated
   */
  void setValue(String value);

} // ActivationProperty
